## This is an example mod with all the essential blocks
## This file will go over: 1:Command block, 2-7:basic building parts, 8-9:Thrusters, 10:Energy generator, 11-16:Basic weapons, 17: Factory block
## USEFUL FOR MODDING:
## RWDK for visualizing the shape of the block and it's scales (https://atg.lychnobi.com/ttftcuts/rwdk)
## Reassembly docs. It contains all the block fields that you need in blocks.lua (http://www.anisopteragames.com/docs)

## Change the values as much as you want to see what happens!
## Don't be afraid to experiment!
## Ask for help in the reassembly discord if you get confused!
## If you dont see an explanation for something you dont know, it will be mentioned in a different block.
{
	{
		1
		## this is the ID of the block, every block has to have a unique ID, or they will replace each other
		name="Command"
		blurb="You need this to control the ship"
		## blurb is the description of the part, you can not write it for no description
		features=COMMAND|GENERATOR|ASSEMBLER|TRACTOR|TORQUER
		## features determine what the block does, and how you use it
		## you can use the reassembly doc
		group=17
		## group determines the faction that this block belongs to
		shape=COMMAND
		durability=2
		density=0.1
		## durability and density DON'T mean the total amount of HP and mass
		## durability and density determines the amount of hp/mass per square unit
		## EXAMPLE: a 1 by 1 square with 1 durability and 0.1 density will have 100 hp and 10 mass
		points=10
		## points determine how much P the block costs
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		## These colors are hex colors. EXCEPT the # at the start of the color is replaced with 0x
		## EXAMPLE: #ffff00 (from hex) -> 0xffff00
		## the color of the block fades from fillColor to fillColor1, and back to fillColor
		growRate=5
		## Higher growRate value means the block grows faster
		##It works similar to durability and density, in such that a 1 by 1 square will grow faster then a 2 by 2 square, even if they both have growRate=5
		powerCapacity=200
		generatorCapacityPerSec=100
		torquerTorque=2000
		## torquerTorque determines how fast the block can turn without using thrusters. Very useful for drones and missiles
		tractorRange=500
		command={
			faction=17
			flags=AGGRESSIVE|WANDER
			## flags, features, shapes and their description can be found in the reassembly docs
		}
	}
	{
		2
		name="Block"
		group=17
		shape=SQUARE
		scale=1
		## default scale is 1, so you can also not write it (like in the command block)
		durability=2
		density=0.1
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
	}
	{
		3
		name="Block"
		group=17
		shape=SQUARE
		scale=2
		durability=2
		density=0.1
		## points arent needed for simple blocks like these that you dont want to cost any points
		## if you dont add points, the game will automatically give the blocks points (0 points for these parts)
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
	}
	{
		4
		name="Corner"
		group=17
		shape=RIGHT_TRI
		scale=1
		durability=2
		density=0.1
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
	}
	{
		5
		name="Corner"
		group=17
		shape=RIGHT_TRI
		scale=2
		durability=2
		density=0.1
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
	}
	## notice how only the shape and scale values differs, yet the hp and mass also differ ingame
	{
		6
		name="R Storage"
		group=17
		shape=OCTAGON
		durability=2
		density=0.1
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
		capacity=250
		## capacity determines how much R the block can hold
	}
	{
		7
		name="Tractor beam"
		features=TRACTOR
		group=17
		shape=OCTAGON
		durability=2
		density=0.1
		points=5
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
		tractorRange=1000
		## tractorRange determines how far the block can pick up R
	}
	{
		8
		name="Thruster"
		blurb="Move the ship around"
		features=THRUSTER
		## TORQUER is rarely used, and isnt generally needed for thrusters. But you can add it if you want to try it out!
		group=17
		shape=DISH_THRUSTER
		scale=1
		durability=2
		density=0.1
		points=1
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=20
		thrusterForce=10000
		thrusterColor=0xff0000
		thrusterColor1=0xffff00
		thrusterBoost=3
		thrusterBoostTime=0.3
		## thrusterBoost determines how much the thrusterForce is multiplied during thrusterBoostTime after activating the thruster.
		##EXAMPLE: thrusterBoost=3 and thrusterForce=10000 means that when the thruster activates, the force of the thruster is 3*10000 or 30000
		## if thrusterBoostTime=1 then the thrusterForce will be 30000 for 1 second
	}
	{
		9
		name="Thruster"
		blurb="Move the ship around"
		features=THRUSTER
		group=17
		shape=DISH_THRUSTER
		scale=2
		durability=2
		density=0.1
		points=3
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=20
		thrusterForce=30000
		thrusterColor=0xff0000
		thrusterColor1=0xffff00
		thrusterBoost=3
		thrusterBoostTime=0.3
	}
	{
		10
		name="Generator"
		blurb="Generates power for the ship to use"
		features=GENERATOR
		group=17
		shape=SQUARE
		scale=1
		durability=2
		density=0.1
		points=30
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		powerCapacity=200
		## powerCapacity determines how much energy can be stored in this block
		generatorCapacityPerSec=100
		## generatorCapacityPerSec determines how much energy is generated per second
	}
	{
		11
		name="Linear cannon"
		blurb="A cannon that shoots in one direction"
		features=CANNON
		group=17
		shape=CANNON
		scale=2
		durability=2
		density=0.1
		points=10
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
		cannon={
			color=0xffffff
			range=1200
			muzzleVel=900
			## muzzleVel determines the speed of the bullet
			roundsPerSec=1
			spread=0.01
			## spread is measured in radians, NOT degrees!
			power=5
			## power determines how much power is used per bullet
			damage=100
			explosive=ENABLED
			explodeRadius=30
			## explosive will deal the same amount of damage inside the explodeRadius
		}
		## Dont forget to close the brackets!
	}
	{
		12
		name="Cannon turret"
		blurb="A cannon that shoots where you aim"
		features=CANNON|TURRET
		## TURRET makes the cannon shoot where you aim it at, it works for both CANNON and LASER
		group=17
		shape=SQUARE
		durability=2
		density=0.1
		points=10
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
		cannon={
			color=0xffffff
			range=800
			muzzleVel=1000
			roundsPerSec=20
			burstyness=1
			## burstyness closer to 1 will make it shoot a bunch of bullets, then wait a bit until shooting again. USeful for shotguns!
			## burstyness closer to 0 will make it shoot normaly, with a more matching delay between bullets
			roundsPerBurst=10
			## roundsPerBurst determines how much bullets get shot in a group
			## if you want burstyness=0, you can skip writing burstyness and roundsPerBurst, like in the linear cannon
			spread=0.2
			power=5
			damage=25
		}
	}
	{
		13
		name="Laser turret"
		blurb="A laser PD turret that shoots down missiles"
		features=LASER|TURRET|AUTOFIRE
		## LASER and CANNON dont work together!
		group=17
		shape=OCTAGON
		durability=2
		density=0.1
		points=6
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
		laser={
			width=1
			power=3
			## power determines how much power is used per second
			damage=15
			color=0xffffffff
			## LASER needs 2 more letters/numbers at the front of the color.
			## its called the alpha value. 0x"ff"ffffff is fully opaque, 0x"00"ffffff is fully transparent
			range=1000
		}
	}
	{
		14
		name="charging super laser"
		blurb="A laser that charges up a powerful shot"
		features=LASER|CHARGING
		## charging works for both LASER and CANNON
		group=17
		shape=CANNON2
		scale=2
		durability=2
		density=0.1
		points=40
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
		chargeMaxTime=2
		chargeMin=0.1
		## chargeMaxTime and chargeMin are counted in seconds
		laser={
			width=3
			power=60
			damage=200
			color=0xffffffff
			range=800
		}
	}
	{
		15
		name="Missile launcher"
		blurb="Launchers explosive homing missiles"
		features=LAUNCHER
		group=17
		shape=RECT_LAUNCHER
		durability=2
		density=0.1
		points=15
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=10
		launcherPower=20
		## launcherPower determines how much energy is needed per missile launched
		replicateTime=3
		## replicateTime determines how long it takes to grow the missile in seconds
		replicateBlock={
			## Here you write your missile just like you would a normal block, in this case a missile
			16
			## launched blocks need their own ID too!
			name="Missile"
			features=COMMAND|THRUSTER|TORQUER|EXPLODE|NOCLIP_ALLY|PERISHABLE
			## NOCLIP_ALLY is useful for drones and missiles to avoid them getting stuck in you faction's ships
			group=17
			shape=MISSILE
			durability=3
			density=0.1
			points=15
			fillColor=0xcc0000
			fillColor1=0xfff000
			lineColor=0x000000
			torquerTorque=5000
			thrusterForce=1000
			thrusterColor=0xff0000
			thrusterColor1=0xffff00
			explodeDamage=30
			explodeRadius=20
			lifetime=10
			## lifetime is written with a small t! time is counted in seconds
			command={
				faction=17
			}
		}
	}
	{
		17
		name="Factory"
		blurb="Used to make new ships"
		features=FACTORY
		group=17
		shape=SQUARE
		scale=3
		durability=2
		density=0.1
		points=100
		fillColor=0xcc0000
		fillColor1=0xfff000
		lineColor=0x000000
		growRate=1
		capacity=200
		## FACTORY is essential for any faction, and is typically very expensive and bulky
	}
}